<template lang='pug'>
BaseCard.x-example(tabIndex='-1')
  template(v-slot:header)
    .d-flex.justify-content-between
      div
        h5 {{ title }}
      .b-clickable(type='button' @click="onSetSelected()")
        i.fa.fa-expand-alt
  li(key='0')
    slot(name='description')
    .d-flex.justify-content-end
      button.mx-1.btn.btn-sm.btn-secondary(v-if='hasSlot("code")' @click='showCode = !showCode') code
      button.mx-1.btn.btn-sm.btn-info(v-if='hasSlot("interface")' @click='showInterface = !showInterface') interface
      button.mx-1.btn.btn-sm.btn-primary(v-if='maxState !== 0'
                                         @click='next()') animate
  li(v-show='showInterface' key='1')
    slot(name='interface')

  li.p-0(v-show='showCode' key='2')
    PugEditor(ref="pugEditor" @change='setTemplate($event)')
      slot(name='code')

  li(key='3' v-if='hasSlot("code")')
    StateComponent(ref='stateCompo' :template='template'
                   :components='components' :maxState='maxState')
  slot(name='default')
</template>
<script>
import { BaseHasSlotMixin } from "@cern/base-vue";

import { invoke } from "lodash";
import PugEditor from "./AppPugEditor.vue";
import StateComponent from "./AppStateComponent.vue";

export default {
  name: "Example",
  components: { StateComponent, PugEditor },
  mixins: [ BaseHasSlotMixin ],
  props: {
    title: { type: String, default: "" },
    maxState: { type: Number, default: 3 },
    components: { type: Object, default: null }
  },
  data() {
    return {
      showCode: false,
      showInterface: false,
      template: "<div></div>",
      hasFocus: false
    };
  },
  watch: {
    showCode() {
      this.$nextTick(() => this.$refs.pugEditor.refresh());
    }
  },
  methods: {
    next() {
      this.$refs.stateCompo.next();
    },
    setTemplate(template) {
      this.template = template;
    },
    onSetSelected() {
      for (let vm = this.$parent; vm; vm = vm.$parent) {
        invoke(vm, "setSelected");
      }
    }
  }
};

</script>
